const parseDatamodelCSV = require("../../datamodel-csv-parser");
const path = require("path");
const fse = require("fs-extra");

module.exports = function generateTableMap(csvPath, outputDir, opts = {}) {
  const { extend, timestamps, verbose, maxNameLength } = opts;

  let log = () => {};
  if (verbose) log = console.log;

  let parseOpts = { log, maxNameLength };

  if (timestamps) {
    parseOpts.timestamps = { created: "createdAt", modified: "updatedAt" };
  }

  if (extend) {
    parseOpts.extendTableMap = require(path.resolve(process.cwd(), extend));
  }

  let fullCsvPath = path.resolve(process.cwd(), csvPath);
  let fullOutputDir = path.resolve(process.cwd(), outputDir, "table-map.json");

  let tableMap = parseDatamodelCSV(fullCsvPath, undefined, parseOpts);
  fse.outputJsonSync(fullOutputDir, tableMap, { spaces: 4 });
  console.log(`Output table-map to ${fullOutputDir}`);
};
