const { getDictionaryDataDirectory } = require('../../../config-utils');
const fs = require('fs');
const path = require('path');
const getModelNameMap = require('../getModelNameMap');

function getDictionaryDataList(tableMap, appConfig){
    let dictionaryDirectory = getDictionaryDataDirectory(appConfig);
    let files = fs.readdirSync(dictionaryDirectory);
    let modelNameMap = getModelNameMap(tableMap);
    let dictList = [];
    files.forEach((fileName) => {
        let ext = path.extname(fileName).toLowerCase();
        if(ext === '.json'){
            let basename = path.basename(fileName, '.json');
            if(modelNameMap[basename]){
                dictList.push({
                    modelName: basename,
                    filePath: path.join(dictionaryDirectory, `${basename}.json`)
                })
            }
        }
    })
    return dictList;
}

module.exports = getDictionaryDataList;

