const _ = require('lodash');
const maxLength = 25;

function shortenName(name, targetLength){
    targetLength = targetLength || maxLength;

    var words = _.snakeCase(name).split('_');

    var newWords = [];

    _.each(words, (word) => {
        var firstLetter = word.substr(0, 1);
        var restOfWord = word.substr(1);
        restOfWord = _.replace(restOfWord, /[aeiou]/g, '');
        newWords.push((firstLetter + restOfWord));
    });

    var shortenedName = _.camelCase(newWords.join('_'));

    if(shortenedName.length <= targetLength) return shortenedName;

    return shortenedName.substr(0, targetLength);
}




module.exports = (function(){
    return {
        shortenName,
        maxLength
    }
})();