const { each } = require("lodash");

module.exports = function addUpdatedByColumn(tableMap, updatedBy, opts) {
  opts = opts || {};  
  each(tableMap, (table, tableName) => {
    if (table.type !== "view") {
      if (updatedBy.modified) {
        var modifiedColName = updatedBy.modified;
        if (typeof table.attributes[modifiedColName] === "undefined") {
          table.attributes[modifiedColName] = {     
            name: modifiedColName,
            columnName: modifiedColName,
            dataType: "UUID",
            isPrimaryKey: false,
            isForeignKey: true,
            size: "",
            precision: "",
            scale: "",
            nullable: true,
            referenceName: "User",
            relAttrName: "updatedByUser",
            referenceKey: "id",
            referenceIdentifying: false,
            referenceIsPlural: true,
            updatedBy: "modified"
          };
        } else {
          if (updatedBy.errorOnConflict) {
            throw new Error(
              `[DM GEN ERROR] updatedBy ${modifiedColName} field already exists on ${tableName}. Unset updatedBy.errorOnConflict to warn instead of throwing.`
            );
          } else {
            console.warn(
              `[DM GEN WARNING] updatedBy ${modifiedColName} field already exists on ${tableName}. Set updatedBy.errorOnConflict throw an error instead of warning`
            );
          }
        }
      }
    }
  });

  return tableMap;
};
