const { each } = require("lodash");

function defaultBooleans(tableMap) {
  each(tableMap, (tableDef) => {
    if (tableDef.type !== "view") {
      each(tableDef.attributes, (attrDef, attrName) => {
        if (attrDef.dataType === "Boolean") {
          attrDef.nullable = false;
          if (!attrDef.defaultValue) {
            attrDef.defaultValue = false;
          }
        }
      });
    }
  });

  return tableMap;
}

module.exports = { defaultBooleans };
