const parseDatamodelCSV = require("../index");
const path = require("path");
const fse = require("fs-extra");
const extendTableMap = require("./test-fixtures/extendTableMap");
const csvPath = path.join(__dirname, "test-fixtures/datamodel-csv-export");
const cleanDeep = require("clean-deep");
describe("datamodel-csv-parser supports views", () => {
  it("parses csv and extends table map with view", () => {
    const expectedTableMap = fse.readJSONSync(
      path.join(__dirname, "test-fixtures/table-map-basic-view.expected.json")
    );
    let tableMap = parseDatamodelCSV(csvPath, undefined, { extendTableMap });
    const outputPath = path.join(
      __dirname,
      "scratch/view-table-maps/table-map-basic-view.json"
    );
    fse.outputJsonSync(outputPath, tableMap);
    tableMap = cleanDeep(tableMap, {
      emptyArrays: false,
      emptyStrings: false,
      emptyObjects: false,
      nullValues: false
    });
    expect(tableMap).toEqual(expectedTableMap);
  });
});
