const { each } = require("lodash");

function getViews(tableMap) {
  let views = [];

  each(tableMap, (entity, entityName) => {
    if (entity.type === "view") {
      views.push({ ...entity, viewName: entityName });
    }
  });
  return views;
}

function setViews(views, tableMap) {
  views.forEach(view => {
    const { viewName, ...viewDef } = view;
    tableMap[viewName] = viewDef;
  });
  return tableMap;
}

module.exports = { getViews, setViews };
