const knex = require("knex");
const Promise = require("bluebird");
const fse = require("fs-extra");
const path = require("path");
const { initDb, applySchema } = require("./knex-tools/");
const {
  syncDictionaryData,
  syncLookupData,
  initSampleData,
} = require("./data-sync");

module.exports = function dropAndSyncDatabase(appConfig, seedFunction, opts) {
  var knexSpecPath = path.join(
    appConfig.graphql.dataLibPath,
    "db/knex-spec.json"
  );
  var knexSpec = require(knexSpecPath);
  var db = knex(appConfig.db.app);

  return initDb(appConfig, opts)
    .then(() => {
      return applySchema(
        db,
        knexSpec,
        seedFunction,
        { ...opts, moduleSchema: true },
        appConfig
      );
    })
    .then(() => {
      return db.destroy();
    });
};
