

module.exports = function convertToGraphQLType(attrDef, attrName){
   
    const typeMap = {
        'VARCHAR': convertVarchar,
        'NUMERIC': convertNumeric,
        'NVARCHAR': convertVarchar,
        'ORDDOC': convertOradoc,
        'TINYINT': convertInteger,
        'TEXT': convertVarchar,
        'TIMESTAMP': convertTimestamp,
        'INTEGER': convertInteger,
        'BOOLEAN': convertBoolean,
        'CLOB': convertVarchar
    };

    if(attrDef.isPrimaryKey || attrDef.isForeignKey || attrDef.isRelatedKey) return `String`;

    var dataTypeName = attrDef.dataType.toUpperCase();

    if(typeof typeMap[dataTypeName] !== 'undefined'){
        
        if(typeof typeMap[dataTypeName] === 'string') dataTypeName = typeMap[dataTypeName];

        return typeMap[dataTypeName](attrDef, attrDef.name);
    }else{
        throw new Error("Unable to convert type " + attrDef.dataType);
    }
}


function convertVarchar(attrDef, attrName) {
    var defStr = `String`;
    //if(!attrDef.nullable) defStr += '!';
    return defStr;
}

function convertNumeric(attrDef, attrName) {
    var defStr = `Number`;
    //if(!attrDef.nullable) defStr += '!';
    return defStr;
}
function convertOradoc(attrDef, attrName) {
    var defStr = `JSON`;
    //if(!attrDef.nullable) defStr += '!';
    return defStr;
}

function convertTimestamp(attrDef, attrName) {
    var defStr = `Date`;
    //if(!attrDef.nullable) defStr += '!';
    return defStr;
}

function convertInteger(attrDef, attrName) {
    var defStr = `Int`;
    //if(!attrDef.nullable) defStr += '!';
    return defStr;
}

function convertBoolean(attrDef, attrName) {
    var defStr = `Boolean`;
    //if(!attrDef.nullable) defStr += '!';
    return defStr;
}
