const _ = require("lodash");
const clone = require("./clone");
const { formatQueryResultName } = require("./name-formats");

module.exports = function extractQueryResultTypes(
  modelName,
  typeAttrs,
  schemaDef
) {
  schemaDef.types[formatQueryResultName(modelName)] = {
    results: { type: modelName, isList: true },
    filter: { type: "JSON" },
    sort: { type: "[String]" },
    pageNumber: { type: "Int" },
    pageSize: { type: "Int" },
    totalResults: { type: "Int" },
    lastFetched: { type: "Date" },
  };
};
