const _ = require("lodash");
const clone = require("./clone");
const {
  formatUpdateInputName,
  formatUpdateInputValuesName,
  formatBatchUpdateInputName,
  formatUpdatePayloadName,
  formatBulkUpdatePayloadName,
  formatBatchUpdatePayloadName,
  formatUpdateQueryInputName,
  formatQueryResultName,
  formatBulkUpdateInputName
} = require("./name-formats");

module.exports = function extractUpdateMutationTypes(
  modelName,
  typeAttrs,
  schemaDef
) {
  var keysToDelete = [];
  var input = clone(typeAttrs);

  _.each(input, (attrDef, attrName) => {
    if (attrDef.isCursor || attrDef.isReadOnly) {
      keysToDelete.push(attrName);
      return;
    }

    // if(attrDef.isForeignKey){
    //     keysToDelete.push(attrName);
    //     return;
    // }

    if (!attrDef.isScalar) {
      attrDef.type = formatUpdateInputName(attrDef.type);
    }
    attrDef.required = attrDef.isKey;
  });

  keysToDelete.forEach(keyName => {
    delete input[keyName];
  });

  schemaDef.inputs[formatUpdateInputName(modelName)] = input;

  var inputValues = clone(typeAttrs);
  keysToDelete = [];

  _.each(inputValues, (attrDef, attrName) => {
    if (attrDef.isKey) {
      keysToDelete.push(attrName);
    } else if (!attrDef.isScalar) {
      keysToDelete.push(attrName);
      //attrDef.type = formatUpdateInputName(attrDef.type);
    } else if (attrDef.isCursor) {
      keysToDelete.push(attrName);
    }
    attrDef.required = false;
  });

  keysToDelete.forEach(keyName => {
    delete inputValues[keyName];
  });

  schemaDef.inputs[formatUpdateInputValuesName(modelName)] = inputValues;

  schemaDef.inputs[formatUpdateQueryInputName(modelName)] = {
    values: {
      type: formatUpdateInputValuesName(modelName),
      isList: false
    },
    where: {
      type: "JSON",
      isScalar: true,
      required: true
    }
  };

  schemaDef.inputs[formatBatchUpdateInputName(modelName)] = {
    updateQueries: {
      type: formatUpdateQueryInputName(modelName),
      isList: true
    }
  };

  schemaDef.types[formatUpdatePayloadName(modelName)] = {
    updatedItemsCursor: {
      type: formatQueryResultName(modelName)
    }
  };

  schemaDef.types[formatBatchUpdatePayloadName(modelName)] = {
    updatedItemsCursor: {
      type: formatQueryResultName(modelName)
    }
  };
};
