module.exports = function getCleanSchemaCommand(dialect, schema) {
  if (dialect === "postgres") {
    return [
      { cmd: "DROP SCHEMA IF EXISTS ?? CASCADE", bindings: [schema] },
      { cmd: "CREATE SCHEMA ?? ", bindings: [schema] },
      {
        cmd: "CREATE EXTENSION IF NOT EXISTS pgcrypto WITH SCHEMA ?? ",
        bindings: [schema],
      },
    ];
  } else if (dialect === "oracle") {
    return [
      {
        cmd: `
                BEGIN
                    FOR tableObj in (
                        select 'drop table "' || object_name || '" cascade constraints purge ' str
                        
                        from all_objects
                        where generated = 'N' and object_type = 'TABLE' and owner = ?
                    )
                    LOOP
                        EXECUTE IMMEDIATE ('' || tableObj.str);
                    END LOOP;


                    FOR userObj in (
                        select 'drop '||object_type||' "' || object_name || '" ' str
                        
                        from all_objects
                        where generated = 'N' and owner = ?
                    )
                    LOOP
                        EXECUTE IMMEDIATE ('' || userObj.str);
                    END LOOP;

                END;`,
        bindings: [schema, schema],
      },
    ];
  }

  throw new Error("Unsupported dialect " + dialect);
};
