const _ = require('lodash');
const pluralize = require('pluralize');

module.exports = (function () {
    return {
        //Query with Results
        formatQueryName(modelName) {
            return modelName + "Cursor";
        },

        formatQueryResultName(modelName) {
            return modelName + "CursorResult";
        },

        //Single Create
        formatCreateMutationName(name) {
            return _.camelCase("create_" + name);
        },

        formatCreateInputName(name) {
            return _.camelCase("create_" + name + "_Input");
        },

        formatCreatePayloadName(name) {
            return _.camelCase("create_" + name + "_Payload");
        },

        //Bulk Create
        formatBulkCreateMutationName(name) {
            return "bulkCreate" + pluralize.plural(name);
        },

        formatBulkCreateInputName(name) {
            return "bulkCreate" + pluralize.plural(name) + "Input";
        },

        formatBulkCreatePayloadName(name) {
            return "bulkCreate" + pluralize.plural(name) + "Payload";
        },
        
        //Single Update
        formatUpdateMutationName(name) {
            return _.camelCase("update_" + name);
        },

        formatUpdateInputName(name) {
            return _.camelCase("update_" + name + "_Input");
        },

        formatUpdatePayloadName(name) {
            return _.camelCase("update_" + name + "_Payload");
        },

        //Bulk Update
        formatBulkUpdateMutationName(name) {
            return "bulkUpdate" + pluralize.plural(name);
        },

        formatBulkUpdateInputName(name) {
            return "bulkUpdate" + pluralize.plural(name) + "Input";
        },

        formatBulkUpdatePayloadName(name) {
            return "bulkUpdate" + pluralize.plural(name) + "Payload";
        },

        //Batch Update
        formatBatchUpdateMutationName(name) {
            return _.camelCase("update_" + pluralize.plural(name) + "_WithQuery");
        },

        formatBatchUpdateInputName(name) {
            return _.camelCase("update_" + pluralize.plural(name) + "_WithQueryInput");
        },

        formatUpdateInputValuesName(name) {
            return _.camelCase("update_" + name + "_ValuesInput");
        },

        formatUpdateQueryInputName(name) {
            return _.camelCase("update_" + name + "_QueryInput");
        },

        formatBatchUpdatePayloadName(name) {
            return _.camelCase("update_" + pluralize.plural(name) + "_WithQueryPayload");
        },

        //Delete Single
        formatDeleteMutationName(name){
            return _.camelCase("delete_" + name);
        },

        formatDeleteInputName(name){
            return _.camelCase("delete_" + name + "_Input");
        },

        formatDeletePayloadName(name){
            return _.camelCase("delete_" + name + "_Payload");
        },

        //Bulk Delete
        formatBulkDeleteMutationName(name){
            return "bulkDelete" + pluralize.plural(name) ;
        },

        formatBulkDeleteInputName(name){
            return "bulkDelete" + pluralize.plural(name)  + "Input";
        },

        formatBulkDeletePayloadName(name){
            return "bulkDelete" + pluralize.plural(name)  + "Payload";
        },

        //Batch Delete
        formatBatchDeleteMutationName(name){
            return _.camelCase("delete_"  + pluralize.plural(name)  + "_WithQuery");
        },

        formatBatchDeleteInputName(name){
            return _.camelCase("delete_"  + pluralize.plural(name)  + "_WithQueryInput");
        },

        formatDeleteInputValuesName(name){
            return _.camelCase("delete_" + name + "_ValuesInput");
        },

        formatDeleteQueryInputName(name){
            return _.camelCase("delete_" + name + "_QueryInput");
        },

        formatBatchDeletePayloadName(name){
            return _.camelCase("delete_"  + pluralize.plural(name)  + "_WithQueryPayload");
        }

    };
})();