const fse = require('fs-extra');
const _ = require('lodash');

module.exports = function loadMockResolvers(mockResolverPath, opts) {

    var mockResolvers = {
        JSON: () => { return { random: "random" }; },
        Date: () => { return new Date(); },
        Number: () => { return getRandomInt(0, 100); }
    }


    if (mockResolverPath && fse.existsSync(mockResolverPath)) {
        var extMockResolvers = require(mockResolverPath);
        mockResolvers = _.assign(mockResolvers, extMockResolvers);
    }

    return mockResolvers;
}

function getRandomInt(min, max) {
    min = Math.ceil(min);
    max = Math.floor(max);
    return Math.floor(Math.random() * (max - min)) + min; //The maximum is exclusive and the minimum is inclusive
}