const fse = require('fs-extra');
const path = require('path');

const scalarTypes = `
    scalar JSON
    scalar Date
    scalar Number

`;

const helloWorldQuery = `
    type Query {
        HelloWorld: String
    }
`;

module.exports = function loadSchemaStr(schemaPath, opts) {
    opts = opts || {};

    var schemaStr = scalarTypes;

    var schemaStrPath;
    if(schemaPath){
        schemaStrPath = path.join(schemaPath, 'schema.gql');
    }

    if (schemaStrPath && fse.existsSync(schemaStrPath)) {
        schemaStr = fse.readFileSync(schemaStrPath, 'utf8');
    } else if (opts.enableMockResolvers) {
        schemaStr += helloWorldQuery;
    }

    return schemaStr;
}