const Promise = require("bluebird");
const { shortenName, maxLength } = require("./datamodel-csv-parser/Utils");
const {
  loadResolvers,
  loadMockResolvers,
  loadSchemaStr,
  loadDataLib,
} = require("./graphql-loader");
const refreshSchema = require("./refresh-schema");
const dropAndSyncDatabase = require("./dropAndSyncDatabase");
const { applyModuleSchema } = require("./applyModuleSchema");
const truncateAndSeedDatabase = require("./truncateAndSeedDatabase");
const knexTools = require("./knex-tools");
const graphqlGenerators = require("./graphql-generator");

module.exports = (function () {
  return {
    applyModuleSchema,
    loadResolvers,
    loadSchemaStr,
    loadMockResolvers,
    loadDataLib,
    refreshSchema,
    generateFakeData: mockPromise,
    dropAndSyncDatabase,
    truncateAndSeedDatabase,
    knexTools,
    graphqlGenerators,
    shortenName,
    maxLength
  };

  function mockPromise() {
    return Promise.resolve();
  }
})();
