const Promise = require("bluebird");

function createExtensions(db, schemaSpec, opts = {}) {
  const { logDebug = () => {}, commonSchema, moduleSchema } = opts;

  db.logSQL(`Creating extensions`);
  return Promise.each(schemaSpec.extensions, (cmdDef) => {
    db.logSQL(cmdDef);
    if (cmdDef.isCommon) {
      if (commonSchema) {
        logDebug(`[ORADM-FUNCTION] Creating common extension`, cmdDef);
        return db.raw(cmdDef.cmd, cmdDef.bindings);
      }
    } else {
      if (moduleSchema) {
        logDebug(`[ORADM-FUNCTION] Creating module extension`, cmdDef);
        return db.raw(cmdDef.cmd, cmdDef.bindings);
      }
    }
  });
}

module.exports = createExtensions;
