const Promise = require("bluebird");

function createFunctions(db, functionCommands, opts = {}) {
  const { logDebug = () => {}, commonSchema, moduleSchema } = opts;
  db.logSQL(`Creating functions`);
  return Promise.each(functionCommands, (cmdDef) => {
    db.logSQL(cmdDef);
    if (cmdDef.isCommon) {
      if (commonSchema) {
        logDebug(`[ORADM-FUNCTION] Creating common function`, cmdDef);
        return db.raw(cmdDef.cmd, cmdDef.bindings);
      }
    } else {
      if (moduleSchema) {
        logDebug(`[ORADM-FUNCTION] Creating module function`, cmdDef);
        return db.raw(cmdDef.cmd, cmdDef.bindings);
      }
    }
  });
}

module.exports = createFunctions;
