const Promise = require("bluebird");

function createTriggers(db, triggerCommands, opts = {}) {
  const { logDebug = () => {}, commonSchema, moduleSchema } = opts;
  db.logSQL(`Creating triggers`);
  return Promise.each(triggerCommands, (cmdDef) => {
    db.logSQL(cmdDef);
    if (cmdDef.isCommon) {
      if (commonSchema) {
        logDebug(`[ORADM-TRIGGER] Creating common trigger`, cmdDef);
        return db.raw(cmdDef.cmd, cmdDef.bindings);
      }
    } else {
      if (moduleSchema) {
        logDebug(`[ORADM-TRIGGER] Creating module trigger`, cmdDef);
        return db.raw(cmdDef.cmd, cmdDef.bindings);
      }
    }
  });
}

module.exports = createTriggers;
