const Promise = require("bluebird");

function createViews(db, views, opts = {}) {
  const { logDebug = () => {}, commonSchema, moduleSchema } = opts;
  db.logSQL(`Creating views`);
  return Promise.each(views, (cmdDef) => {
    db.logSQL(cmdDef);
    if (cmdDef.isCommon) {
      if (commonSchema) {
        logDebug(`[ORADM-VIEW] Creating common view`, cmdDef);
        return db.raw(cmdDef.cmd, cmdDef.bindings);
      }
    } else {
      if (moduleSchema) {
        logDebug(`[ORADM-VIEW] Creating module view`, cmdDef);
        return db.raw(cmdDef.cmd, cmdDef.bindings);
      }
    }
  });
}

module.exports = createViews;
