const knex = require('knex');
const doesSchemaExist = require('./doesSchemaExist');
const createSchema = require('./createSchema');
const createStoredProcedures = require('./createStoredProcedures');

module.exports = function initDb(dbConfig, opts){
    opts = opts || {};
    var log = opts.log || function(){};

    // Create Sequelize instance. 
    var db = knex(dbConfig.sys); 

    return doesSchemaExist(db, dbConfig.appSchema)
    .then((result) => {
        if(result){
            return Promise.resolve();
        }else{
            return createSchema(db, dbConfig.appSchema, dbConfig.app.connection.password).then(function (args) {
                return createStoredProcedures(db, dbConfig.appSchema, dbConfig.app.connection.password);
            });
        }
    });
}