const Promise = require('bluebird');
var dropAndRecreateSequences = require('./dropAndRecreateSequences');
var truncateAndSeedSQLOracle = `
  declare

  begin

  for c1 in (select y1.table_name, y1.constraint_name from user_constraints y1, user_tables x1 where x1.table_name = y1.table_name order by y1.r_constraint_name nulls last) loop
      begin
          execute immediate  ('alter table "'||c1.table_name||'" disable constraint "'||c1.constraint_name || '"');
      end;
  end loop;

  for t1 in (select table_name from user_tables) loop
      begin
          execute immediate ('truncate table "'||t1.table_name || '"');
      end;
  end loop;

  end;
`

module.exports = function truncateSchema(db, appConfig, opts) {
  console.log("Truncating tables...")
	return db.raw(truncateAndSeedSQLOracle)
  .then((result)=>{
    console.log(result)
    console.log("Truncate OK")
    return Promise.resolve();
  })
  .catch((err)=>{
    console.log("Truncate failed")
    console.log(err)
    return Promise.reject(err);
  })
  .then(()=>{ return dropAndRecreateSequences(db, appConfig, opts) })
	// .then((result) => {
	// 	return Promise.resolve((result.length > 0));
	// });

}