const knex = require('knex');

module.exports = function initDb(dbConfig, opts){
    opts = opts || {};
    var log = opts.log || function(){};

    // Create Sequelize instance. 
    var db = knex(dbConfig.sys); 
    var dbName = dbConfig.dbName;

    return db.raw('SELECT 1 "db_exists" FROM pg_database WHERE datname = ?', [dbName])
    .then((result) => {
        log(result);
        if(result.rows.length === 0){
            return db.raw('CREATE DATABASE ?? ', [dbName]);
        }else{
            return Promise.resolve();
        }
    });
}