const Promise = require('bluebird');

module.exports = function resetSequences(db, appConfig, opts){

    return db.raw(`
SELECT  'ALTER SEQUENCE ' ||S.relname|| ' RESTART WITH 1;'
FROM pg_class AS S, pg_depend AS D, pg_class AS T, pg_attribute AS C
WHERE S.relkind = 'S'
    AND S.oid = D.objid
    AND D.refobjid = T.oid
    AND D.refobjid = C.attrelid
    AND D.refobjsubid = C.attnum
ORDER BY S.relname;
    `)
    .then(function (results) {
	    return Promise.each(results.rows, (row) => {
	        var sql = row['?column?'];
	        console.log(sql)
	        return db.raw(sql)
	        .then(function(){ console.log("OK"); return Promise.resolve(); })
	        .catch(function(e){ console.log("Failed"); return Promise.resolve(); })
	    })
    })


}