var resetSequences = require('./resetSequences');
const Promise = require('bluebird');

const truncateAndSeedSQLPostgres = `
SELECT 'TRUNCATE TABLE '
   || string_agg(quote_ident(schemaname) || '.' || quote_ident(tablename), ', ')
   || ' CASCADE' as query
FROM   pg_tables
WHERE  schemaname = 'app'
;
`

module.exports = function truncateSchema(db, appConfig, opts) {
    return db.raw(truncateAndSeedSQLPostgres)
    .then((result)=>{
        return result.rows[0].query
    })
    .then((query)=>{
        return db.raw(query)
    })
    .then((results)=>{
        console.log(results)
        console.log("Truncate OK")
        return Promise.resolve();
    })
    .catch((err)=>{
        console.log("Truncate failed")
        console.log(err)
        return Promise.reject(err);
    })
    .then(()=>{ return resetSequences(db, appConfig, opts) })

}