
const fs = require('fs');
const logSQL = require('./logSQL');

function initSQLLogging(db){
    db.logSQL = logSQL;

    if(process.env.generateSQL) {
      let generatedSQLPath = '/tmp/output.sql';
      if (process.env.generateSQLPath) generateSQLPath = process.env.generateSQLPath;
      else process.env.generateSQLPath = generatedSQLPath;
      console.log(`Generating output SQL at: ${generatedSQLPath}`);
      fs.writeFileSync(generatedSQLPath,"",{encoding:'utf8',flag:'w'})
    }
}

module.exports = initSQLLogging;