const knex = require('knex');
const Promise = require('bluebird');
const fse = require('fs-extra');
const path = require('path');
const { initDb, truncateSchema } = require('./knex-tools/');
module.exports = function truncateAndSeedDatabase(appConfig, seedFunction, opts) {
    var db = knex(appConfig.db.app);

    return initDb(appConfig, opts)
        .then(() => {
            return truncateSchema(db, appConfig, opts);
        })
        .then(() => {
            if (seedFunction) {
                console.log("Loading seed data..")
                return seedFunction(db).then(function () {
                    console.log("Loading seed data.. OK")
                    return Promise.resolve();
                }).catch(function (err) {
                    console.log(err)
                    console.log("Loading seed data.. FAILED")
                    return Promise.reject(err)
                })
            } else {
                return Promise.resolve();
            }
        });
}