const generateDataLibTests = require('../generateDataLibTests');

describe("generateDataLibTests", () => {
    it("exports function", () => {
        expect(typeof generateDataLibTests).toBe('function');
    });

    it("returns an array", () => {
        const tableMap = require('../test-data/example-table-map.json');
        const config = require('../test-data/example-config');

        let output = generateDataLibTests(tableMap, config);

        expect(Array.isArray(output)).toBeTruthy();
    });

    it("generates a unit test for each entity", () => {
        const tableMap = require('../test-data/example-table-map.json');
        const config = require('../test-data/example-config');
        const expectedOutput = require('./tests/expected-entity-files.json');
        let output = generateDataLibTests(tableMap, config);

        expect(output).toEqual(expectedOutput);
    });
});