const path = require("path");
const fse = require("fs-extra");

module.exports = function cleanFolders(appConfig, opts){

    fse.removeSync(path.join(appConfig.graphql.schemaPath, "core"));
    fse.removeSync(path.join(appConfig.graphql.resolversPath, "core"));
    fse.removeSync(path.join(appConfig.graphql.resolversPath, "index.js"));
    fse.removeSync(path.join(appConfig.graphql.dataLibPath, "core"));
    fse.removeSync(path.join(appConfig.graphql.dataLibPath, "entities"));
    fse.removeSync(path.join(appConfig.graphql.dataLibPath, "index.js"));

    fse.removeSync(path.join(appConfig.graphql.dataLibPath, "db/knex-spec.json"));
    fse.removeSync(path.join(appConfig.graphql.schemaPath, "schema.gql"));
    fse.removeSync(path.join(appConfig.graphql.schemaPath, "schema-spec.json"));
    fse.removeSync(path.join(appConfig.graphql.dataLibPath, "db/table-map.json"));

    fse.ensureDirSync(path.join(appConfig.graphql.schemaPath, "core"));
    fse.ensureDirSync(path.join(appConfig.graphql.resolversPath, "core"));
    fse.ensureDirSync(path.join(appConfig.graphql.dataLibPath, "core"));
    fse.ensureDirSync(path.join(appConfig.graphql.dataLibPath, "entities"));

    fse.ensureDirSync(path.join(appConfig.graphql.schemaPath, "ext"));
    fse.ensureDirSync(path.join(appConfig.graphql.resolversPath, "ext"));
    fse.ensureDirSync(path.join(appConfig.graphql.dataLibPath, "ext"));

    fse.ensureDirSync(path.join(appConfig.graphql.dataLibPath, "db"));
    fse.ensureDirSync(path.join(appConfig.graphql.dataLibPath, "db/dict-data"));
    fse.ensureDirSync(path.join(appConfig.graphql.dataLibPath, "db/lookup-data"));
    fse.ensureDirSync(path.join(appConfig.graphql.dataLibPath, "db/sample-data"));

    // fse.removeSync(path.join(appConfig.graphql.schemaPath, "fixtures/table-map.json"));
    // fse.removeSync(path.join(appConfig.graphql.schemaPath, "fixtures/index.js"));

    // fse.ensureDirSync(path.join(appConfig.graphql.schemaPath, "fixtures/seed/data"));
    // fse.ensureDirSync(path.join(appConfig.graphql.schemaPath, "fixtures/extra"));


}