const { each } = require('lodash');

module.exports = function configureCommands(commands, program) {
    each(commands, (cmdSpec) => {
        let {
            command,
            action,
            description,
            options,
            alias
        } = cmdSpec;

        let cmd = program.command(command);
        if (alias) cmd = cmd.alias(alias);
        if (description) cmd = cmd.description(description);
        if (options) {
            each(options, (optDesc, optSpec) => {
                cmd = cmd.option(optSpec, optDesc);
            });
        }
        cmd.action(action);
    });
}
